// Copyright (C) 1999 Jean-Marc Valin

#ifndef GMMTRAIN_H
#define GMMTRAIN_H

#include "Node.h"
#include "ObjectRef.h"

class GMMTrain : public Node {

protected:
   
   /**The ID of the 'output' output*/
   int outputID;

   /**The ID of the 'frames' input*/
   int framesInputID;

   /**Reference to the current stream*/
   ObjectRef currentGMM;

   int processCount;

   int splitLevels;
public:
   /**Constructor, takes the name of the node and a set of parameters*/
   GMMTrain(string nodeName, ParameterSet params);

   /**Class specific initialization routine.
      Each class will call its subclass specificInitialize() method*/
   virtual void specificInitialize();

   /**Class reset routine.
      Each class will call its superclass reset() method*/
   virtual void reset();

   /**Ask for the node's output which ID (number) is output_id 
      and for the 'count' iteration */
   virtual ObjectRef getOutput(int output_id, int count); 

protected:
   /**Default constructor, should not be used*/
   GMMTrain() {throw new GeneralException("GMMTrain copy constructor should not be called",__FILE__,__LINE__);}

};

#endif
